// copyright 1999 ZF MicroSystems, Inc. All rights reserved.
// Tests WDT INT 15 Tickle Function

#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

void main(argc,argv)
int argc;
char *argv[];
{
char tbuffer[9];
union REGS inregs, outregs;
int delay_value=0;
time_t t1,t2;

if(argc !=2)                            // only two args allowed
   { printf("\nCommand Line Error: \n");
     printf("Format: WDTON <secs>  i.e WDTON 10"); exit(EXIT_FAILURE);}

delay_value = (abs(atoi(argv[1])));

system("cls");

if (delay_value >255)
   { printf("\nDelay Value greater than 255, truncating to 255 seconds.\n");
     delay_value = 255; }

printf("\nWatch Dog Timer Tickle Test\n");
printf("\nSystem will REBOOT in %2.2d seconds",delay_value);
printf("\nStart Time   %s\n", _strtime (tbuffer));

time(&t1);

inregs.x.ax = 0xc301;
inregs.x.bx = delay_value;
int86(0x15 ,&inregs, &outregs);
if ( outregs.x.cflag )
   printf("\nINT 15 function C3 01 failed CF = %x\n", outregs.x.cflag);

while ((difftime(t2,t1) != delay_value+1))
   {
   printf("Tickling WDT %s\r", _strtime (tbuffer));
   time(&t2);
   }
printf("WDT FAILED   %s\n", _strtime (tbuffer));
  printf("Waiting 5 more seconds:\n");
while ((difftime(t2,t1) < delay_value+7))
  {
  printf("             %s\r", _strtime (tbuffer));
  time(&t2);
  }
}
